# $Revision: 1.10 $, $Date: 2011/02/02 19:26:16 $

Summary:	Run user scripts
Summary(pl.UTF-8):	Uruchom skrypty użytkownika
Name:		rc-scripts-user
Version:	1.8
Release:	1
License:	GPL v2+
Group:		Applications/System
Source0:	userscripts.init
Source1:	run-fast-or-hide.c
URL:		http://www.pld-linux.org/Packages/UserScripts
BuildRequires:	rpmbuild(macros) >= 1.228
Requires(post,preun):	/sbin/chkconfig
Requires:	rc-scripts
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Run user-defined scripts on system startup and shutdown.

%description -l pl.UTF-8
Uruchom skrypty użytkownika przy starcie oraz wyłączaniu systemu.

%prep
%setup -q -c -T
awk '/Version/ { v=$4 } END { exit v != "%{version}" }' < %{SOURCE0}

%build
%{__cc} %{rpmcppflags} %{rpmcppflags} -Wall %{rpmldflags} %{SOURCE1} -o run-fast-or-hide

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/{sysconfig,rc.d/init.d}
install -d $RPM_BUILD_ROOT/sbin

install -p run-fast-or-hide $RPM_BUILD_ROOT/sbin
install -p %{SOURCE0} $RPM_BUILD_ROOT/etc/rc.d/init.d/userscripts

cat <<'EOF' > $RPM_BUILD_ROOT/etc/sysconfig/userscripts
# If ALLOWED list is not empty, only users from this list will be able
# to run their scripts. Otherwise anyone with valid login shell will be
# allowed.
ALLOWED=""

# List of users which are never allowed to run scripts:
# BANNED="root guest"
BANNED=""

# userscripts does not wait for user actions to finish, how much time,
# in seconds, should it wait before continuing system shutdown.
STOP_WAIT_TIME=2

# Script priority
NICE=15

# maximum number of scripts run for every user
MAX_USER_SCRIPTS=20

# additional arguments for run-fast-or-hide,
# check: run-fast-or-hide --help for more info
# RUN_ARGS="-s 50000"

EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add userscripts
%service -q userscripts restart

%preun
if [ "$1" = "0" ]; then
	%service -q userscripts stop
	/sbin/chkconfig --del userscripts
fi

%files
%defattr(644,root,root,755)
%attr(755,root,root) /sbin/run-fast-or-hide
%attr(754,root,root) /etc/rc.d/init.d/userscripts
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/userscripts

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: rc-scripts-user.spec,v $
Revision 1.10  2011/02/02 19:26:16  sparky
- updated to: 1.8
- service userscripts restart is back - it should make no harm to user scripts

Revision 1.9  2011/02/01 09:32:28  sparky
- updated to: 1.7
-- use getent passwd to grab all users, not only local ones (thx glen, arekm)
-- force /bin/sh in su wrepper to make sure quoting works as we expect it

Revision 1.8  2011/02/01 01:09:14  sparky
- updated to: 1.6
-- implemented script limit (by default only 20 scripts for each user)
-- only allow valid shells from /etc/shells (ignore comments, must be
   executable)
-- better service name

Revision 1.7  2011/01/31 21:06:25  glen
- use .init suffix

Revision 1.6  2011/01/31 19:34:07  sparky
- 1.5: back to "su" for user management

Revision 1.5  2011/01/31 19:10:58  sparky
- allow passing arguments to run-fast-or-hide

Revision 1.4  2011/01/31 18:44:00  sparky
- updated to: 1.3, mostly cosmetics

Revision 1.3  2011/01/31 18:30:10  sparky
- compile run-fast-or-hide
- no longer noarch
- init script updated to: 1.2

Revision 1.2  2011/01/31 01:33:59  sparky
- don't restart in %post

Revision 1.1  2011/01/31 01:22:27  sparky
- NEW: runs user-devined scripts on system startup
